/***************************************************************************
 *   Copyright (C) 2004 by Milan Mimica                                    *
 *   milan.mimica@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "ammo_pack.h"


#define AMMO_COUNT_STR std::string("ammo_count")
#define WEAPON_INDEX_STR std::string("weapon_index")


AmmoPack::AmmoPack(const TiXmlElement* Att , float Scale) :
	Object(Att, Scale),
	IncrecreaseObject(Att, Scale) {

	const TiXmlElement *Root = Parser->GetRoot();

	WeaponIndex = XMLParser::GetValueL(Root, WEAPON_INDEX_STR, 0);
	AmmoCount = XMLParser::GetValueL(Root, AMMO_COUNT_STR, 0);
}


bool AmmoPack::Increcrease(PlayerObject *PlaObj) {
	return PlaObj->AddAmmo(WeaponIndex, AmmoCount);
}
