/***************************************************************************
 *   Copyright (C) 2004 by Milan Mimica                                    *
 *   milan.mimica@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifdef _WIN32
	#include <allegro.h>
	#include <winalleg.h>
#endif

#include "floating_object.h"
#include "network_server.h"
#include "object_extension.h"

extern NetworkServer *gNetworkServer;
extern float gTimeElapsed;


FloatingObject::FloatingObject(const TiXmlElement *Att, float Scale) :
	Object(Att, Scale),
	MobileObject(Att, Scale) {

	gNetworkServer->Add(this, Object::ObjectUID);
}


void FloatingObject::OnUpdate() {
	if (Extension[0]->NeedsUpdate(gTimeElapsed))
		Extension[0]->Update();

	MobileObject::OnUpdate();
}


void FloatingObject::Unlink() {
	gNetworkServer->RemoveFloatingObj(Object::ObjectUID);
	MobileObject::Unlink();
}

