/***************************************************************************
 *   Copyright (C) 2004 by Milan Mimica                                    *
 *   milan.mimica@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef GAME_LOGIC_H
#define GAME_LOGIC_H

#include "spawn_place.h"

#include <string>
#include <vector>


class GameLogic {
public:
	void AddSpawnPlace(SpawnPlace* New);
	void RemoveSpawnPlace(SpawnPlace* New);
	SpawnPlace* GetFreeSpawnPlace();

	bool CanCollide(const ULONG Obj1, const ULONG Obj2) const;

private:
	std::vector<SpawnPlace*> SpawnPlaceList;
	std::vector<SpawnPlace*> FreeSpawnPlace;
};


#endif
