/***************************************************************************
 *   Copyright (C) 2004 by Milan Mimica                                    *
 *   milan.mimica@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "logging_console.h"

#include <iostream>
#include <zig/log.h>


LoggingConsole::LoggingConsole() :
	UseStdout(true),
	LogID(0) {
}


LoggingConsole::LoggingConsole(const std::string &LogFileName1, const std::string &LogFileName2, size_t Size) :
	UseStdout(false),
	LogID(log_open(LogFileName1.c_str(), LogFileName2.c_str(), Size, false, true)) {

	if (!LogID)
		std::cout << "Cannot open file '" << LogFileName1 << "' for writing!";
}


LoggingConsole::~LoggingConsole() {
	if (LogID)
		log_close(LogID);
}


void LoggingConsole::write_string(const char* outstr) {
	if (UseStdout)
		std::cout << outstr;
	else
		log(LogID, "%s", outstr);

	return console_c::write_string(outstr);
}
