/***************************************************************************
 *   Copyright (C) 2004 by Milan Mimica                                    *
 *   milan.mimica@gmail.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef SERVER_ONLY


#ifndef PROGRESS_BAR_H
#define PROGRESS_BAR_H

#include "object_extension.h"

class AGLBitmap;


class ProgressBar : public ObjectExtension {
public:
	ProgressBar(const TiXmlElement *Element, const Rect<float> &ParentSize);
	~ProgressBar();

	void SetPercent(float Percent);
	void SetVisible(bool V) {Visible = V;}

	virtual void Render(const Point<float> &Where, const float &Angle) const;
	virtual void RenderShape(BITMAP *, BITMAP *) {};
	virtual void Update() {}
	virtual bool NeedsUpdate(float TimeElapsed) {return false;}

private:
	AGLBitmap *BarBmp;
	AGLBitmap *BackBmp;

	float Percent;
	bool Visible;
};


#endif

#endif //SERVER_ONLY
